-- Version 0.55
with trace
include get.e
include wildcard.e
constant REGISTER = 1,
	 VALUE = 2,
	 MEMORY = 3
constant BYTE = 1,
	 WORD = 2,
	 DWORD = 3
sequence registers, memory
sequence code, labels
integer ip
registers = repeat(0,6)
memory = {}
function GetValue(sequence ptr)
    atom value
    value = 0
    if ptr[1] =  REGISTER then
	if equal(ptr[2],"eax") then
	    value = registers[1] 
	elsif equal(ptr[2],"ebx") then
	    value = registers[2]
	elsif equal(ptr[2],"ecx") then
	     value = registers[3]
	elsif equal(ptr[2],"edx") then
	    value = registers[4]
	elsif equal(ptr[2],"edi") then
	    value = registers[5]
	elsif equal(ptr[2],"esi") then
	    value = registers[6]
	elsif equal(ptr[2],"ax") then
	    value = remainder(registers[1],65536)
	elsif equal(ptr[2],"bx") then
	    value = remainder(registers[2],65536)
	elsif equal(ptr[2],"cx") then
	    value = remainder(registers[3],65536)
	elsif equal(ptr[2],"dx") then
	    value = remainder(registers[4],65536)
	elsif equal(ptr[2],"al") then
	    value = remainder(registers[1],256)
	elsif equal(ptr[2],"bl") then
	    value = remainder(registers[2],256)
	elsif equal(ptr[2],"cl") then
	    value = remainder(registers[3],256)
	elsif equal(ptr[2],"dl") then
	    value = remainder(registers[4],256)
	elsif equal(ptr[2],"ah") then
	    value = floor(remainder(registers[1],65536)/256)
	elsif equal(ptr[2],"bh") then
	    value = floor(remainder(registers[2],65536)/256)
	elsif equal(ptr[2],"ch") then
	    value = floor(remainder(registers[3],65536)/256)
	elsif equal(ptr[2],"dh") then
	    value = floor(remainder(registers[4],65536)/256)
	else
	    for i = 1 to length(labels) do
		if equal(ptr[2],labels[i][1]) then
		    value = labels[i][2]
		    exit
		end if
	    end for
	end if
    elsif ptr[1] = MEMORY then
	ptr[3] = GetValue(ptr[3])
	if ptr[2] = BYTE then
	    value = memory[ptr[3]]
	elsif ptr[2] = WORD then
	    value = memory[ptr[3]] + (memory[ptr[3]+1]*256)
	elsif ptr[2] = DWORD then
	    value = memory[ptr[3]] + (memory[ptr[3]+1]*256) + (memory[ptr[3]+2]*65536) + (memory[ptr[3]+3]*16777216)
	end if
    elsif ptr[1] = VALUE then
	value = ptr[2]
    end if
    return value
end function
procedure StoreValue(sequence ptr, atom value)
    if ptr[1] = REGISTER then
	if equal(ptr[2],"eax") then
	    registers[1] = value
	elsif equal(ptr[2],"ebx") then
	    registers[2] = value
	elsif equal(ptr[2],"ecx") then
	    registers[3] = value
	elsif equal(ptr[2],"edx") then
	    registers[4] = value
	elsif equal(ptr[2],"edi") then
	    registers[5] = value
	elsif equal(ptr[2],"esi") then
	    registers[6] = value
	elsif equal(ptr[2],"ax") then
	    registers[1] = (floor(registers[1]/65536)*65536)+value
	elsif equal(ptr[2],"bx") then
	    registers[2] = (floor(registers[2]/65536)*65536)+value
	elsif equal(ptr[2],"cx") then
	    registers[3] = (floor(registers[3]/65536)*65536)+value
	elsif equal(ptr[2],"dx") then
	    registers[4] = (floor(registers[4]/65536)*65536)+value
	elsif equal(ptr[2],"al") then
	    registers[1] = (floor(registers[1]/256)*256)+value
	elsif equal(ptr[2],"bl") then
	    registers[2] = (floor(registers[2]/256)*256)+value
	elsif equal(ptr[2],"cl") then
	    registers[3] = (floor(registers[3]/256)*256)+value
	elsif equal(ptr[2],"dl") then
	    registers[4] = (floor(registers[4]/256)*256)+value
	elsif equal(ptr[2],"ah") then
	    registers[1] = (floor(registers[1]/65536)*65536)+(value*256)+remainder(registers[1],256)
	elsif equal(ptr[2],"bh") then
	    registers[2] = (floor(registers[2]/65536)*65536)+(value*256)+remainder(registers[2],256)
	elsif equal(ptr[2],"ch") then
	    registers[3] = (floor(registers[3]/65536)*65536)+(value*256)+remainder(registers[3],256)
	elsif equal(ptr[2],"dh") then
	    registers[4] = (floor(registers[4]/65536)*65536)+(value*256)+remainder(registers[4],256)
	end if
    elsif ptr[1] = MEMORY then
	ptr[3] = GetValue(ptr[3])
	if ptr[2] = BYTE then
	    memory[ptr[3]] = value
	elsif ptr[2] = WORD then
	    memory[ptr[3]] = remainder(value,256)
	    memory[ptr[3]+1] = floor(value/256)
	elsif ptr[2] = DWORD then
	    memory[ptr[3]] = remainder(value,256)
	    memory[ptr[3]+1] = remainder(floor(value/256),256)
	    memory[ptr[3]+2] = remainder(floor(value/65536),256)
	    memory[ptr[3]+3] = floor(value/16777216)
	end if
    end if
end procedure
procedure mov(sequence a, sequence b)
    StoreValue(a,GetValue(b))
    ip += 1
end procedure
procedure add(sequence a, sequence b)
    StoreValue(a,GetValue(b)+GetValue(a))
    ip += 1
end procedure
procedure sub(sequence a, sequence b)
    StoreValue(a,GetValue(a)-GetValue(b))
    ip += 1
end procedure
procedure mul(sequence a)
    StoreValue({REGISTER,"eax"},GetValue({REGISTER,"eax"})*GetValue(a))
    ip += 1
end procedure
sequence stack
stack = {}
procedure push(sequence a)
    stack &= GetValue(a)
    ip += 1
end procedure
procedure pop(sequence a)
    StoreValue(a,stack[length(stack)])
    stack = stack[1..length(stack)-1]
    ip += 1
end procedure
procedure xchg(sequence a, sequence b)
    atom c, d
    c = GetValue(a)
    d = GetValue(b)
    StoreValue(a,d)
    StoreValue(b,c)
    ip += 1
end procedure
procedure shl(sequence a, sequence b)
    StoreValue(a,{VALUE,floor(GetValue(a)/power(2,GetValue(b)))})
    ip += 1
end procedure
procedure shr(sequence a, sequence b)
    StoreValue(a,{VALUE,GetValue(a)*power(2,GetValue(b))})
    ip += 1
end procedure
procedure inc(sequence a)
    StoreValue(a,GetValue(a)+1)
    ip += 1
end procedure
procedure dec(sequence a)
    StoreValue(a,GetValue(a)-1)
    ip += 1
end procedure
procedure And(sequence a, sequence b)
    StoreValue(a,and_bits(GetValue(a),GetValue(b)))
    ip += 1
end procedure
procedure jmp(sequence a)
    ip = GetValue(a)
end procedure
procedure cmp(sequence a, sequence b)
    ip += 1
    if equal(code[ip][1],"je") then
	if GetValue(a)=GetValue(b) then
	    jmp(code[ip][2][1])
	    return
	end if
    elsif equal(code[ip][1],"jne") then
	if GetValue(a)!=GetValue(b) then
	    jmp(code[ip][2][1])
	    return
	end if
    end if
    ip += 1
end procedure
procedure jcxz(sequence a)
    if GetValue({REGISTER,"ecx"}) = 0 then
	jmp(a)
    else
	ip += 1
    end if
end procedure
procedure loop(sequence a)
    dec({REGISTER,"ecx"})
    if GetValue({REGISTER,"ecx"}) > 0 then
	jmp(a)
    else
	ip += 1
    end if
end procedure
function sep(sequence s)
    sequence tokens
    tokens = {""}
    for i = 1 to length(s) do
	if s[i] = ' ' then
	    tokens = append(tokens,"")
	elsif s[i] = ',' then
	    tokens = append(tokens,",")
	    tokens = append(tokens,"")
	else
	    tokens[length(tokens)] &= s[i]
	end if
    end for
    return tokens
end function
function sepspc(sequence s)
    sequence tokens
    tokens = {""}
    for i = 1 to length(s) do
	if s[i] = ' ' then
	    tokens = append(tokens,"")
	else
	    tokens[length(tokens)] &= s[i]
	end if
    end for
    return tokens
end function
procedure loadCode(integer f)
    object line, t
    sequence op, args
    labels = {{"end",0}}
    code = {}
    memory = {}
    ip = 1
    line = gets(f)
    while sequence(line) do
	if length(line)=1 and f = 0 then
	    exit
	end if
	line = sep(line[1..length(line)-1])
	while find("",line) do
	    line = line[1..find("",line)-1] & line[find("",line)+1..length(line)]
	end while
	for i = 1 to length(line) do
	    line[i] = lower(line[i])
	end for
	if length(line) = 1 then
	    labels = append(labels,{line[1][1..length(line[1])-1],length(code)+1})
	else
	    op = line[1]
	    args = {0}
	    t = value(line[2])
	    if t[1] = GET_SUCCESS then
		args[1] = {VALUE,t[2]}
	    else
		if equal(line[2],"byte") then
		    args[1] = {MEMORY,BYTE,{REGISTER,line[4][2..length(line[4])-1]}}
		elsif equal(line[2],"word") then
		    args[1] = {MEMORY,WORD,{REGISTER,line[4][2..length(line[4])-1]}}
		elsif equal(line[2],"dword") then
		    args[1] = {MEMORY,DWORD,{REGISTER,line[4][2..length(line[4])-1]}}
		else
		    args[1] = {REGISTER,line[2]}
		end if
	    end if
	    if find(",",line) then
		args = append(args,0)
		line = line[find(",",line)..length(line)]
		t = value(line[2])
		if t[1] = GET_SUCCESS then
		    args[2] = {VALUE,t[2]}
		else
		    if equal(line[2],"byte") then
			args[2] = {MEMORY,BYTE,{REGISTER,line[4][2..length(line[4])-1]}}
		    elsif equal(line[2],"word") then
			args[2] = {MEMORY,WORD,{REGISTER,line[4][2..length(line[4])-1]}}
		    elsif equal(line[2],"dword") then
			args[2] = {MEMORY,DWORD,{REGISTER,line[4][2..length(line[4])-1]}}
		    else
			args[2] = {REGISTER,line[2]}
		    end if
		end if
	    end if
	    code = append(code,{op,args})
	end if
	puts(1,'\n')
	line = gets(f)
    end while
    for i = 1 to length(code) do
	if equal(code[i][1],"and") then
	    code[i][1] = "And"
	end if
    end for
end procedure
procedure display_arg(sequence arg)
    if arg[1] = REGISTER then
	puts(1,arg[2] & '\n')
    elsif arg[1] = MEMORY then
	if arg[2] = BYTE then
	    puts(1,"byte ptr ")
	elsif arg[2] = WORD then
	    puts(1,"word ptr ")
	elsif arg[2] = DWORD then
	    puts(1,"dword ptr ")
	end if
	display_arg(arg[3])
    elsif arg[1] = VALUE then
	printf(1,"%d\n",arg[2])
    end if
end procedure
function sprint(object x)
    sequence s
    if atom(x) then
	return sprintf("%d",x)
    else
	s = "{"
	for i = 1 to length(x)-1 do
	    s &= sprint(x[i]) & ","
	end for
	if length(x) then
	    s &= sprint(x[length(x)]) & "}"
	end if
	return s
    end if
end function
procedure debugger(integer f)
    object line
    object t, t2
    object output
    line = gets(f)
    output = 0
    while sequence(line) do
	puts(1,'\n')
	line = sepspc(lower(line[1..length(line)-1]))
	while find("",line) do
	    line = line[1..find("",line)-1] & line[find("",line)+1..length(line)]
	end while
	while find("$",line) do
	    line[find("$",line)] = sprint(output)
	end while
	if length(line) then
	    if equal(line[1],"load") then
		puts(1,"\nloading code...\n")
		if length(line) = 1 then
		    loadCode(0)
		    puts(1,"\ncode loaded.\n")
		else
		    t = open(line[2],"r")
		    if t = -1 then
			puts(1,"can't open " & line[2] & "\n")
		    else
			loadCode(t)
			close(t)
			puts(1,"\ncode loaded.\n")
		    end if
		end if
	    elsif equal(line[1],"run") then
		puts(1,"\nrunning...\n")
		if ip = -1 then
		    puts(1,"no code to run.\n")
		elsif ip = 0 then
		    if length(code) = 0 then
			puts(1,"no code to run.\n")
		    else
			ip = 1
		    end if
		end if
		while ip > 0 and ip <= length(code) do
		    if routine_id(code[ip][1]) = -1 then
			puts(1,"can't find operation " & code[ip][1] & '\n')
			exit
		    end if
		    call_proc(routine_id(code[ip][1]),code[ip][2])
		end while
		ip = 0
		puts(1,"\ndone.\n")
	    elsif equal(line[1],"step") then
		puts(1,"\nrunning...\n")
		if ip = -1 then
		    puts(1,"no code to run.\n")
		elsif ip = 0 then
		    if length(code) = 0 then
			puts(1,"no code to run.\n")
		    else
			ip = 1
		    end if
		end if
		if ip > 0 and ip <= length(code) then
		    if routine_id(code[ip][1]) = -1 then
			puts(1,"can't find operation " & code[ip][1] & '\n')
		    else
			call_proc(routine_id(code[ip][1]),code[ip][2])
		    end if
		end if
	    elsif equal(line[1],"code") then
		if ip = -1 then
		    puts(1,"no code to display.\n")
		elsif ip = 0 then
		    if length(code) = 0 then
			puts(1,"no code to display.\n")
		    else
			ip = 1
		    end if
		end if
		if ip > 0 and ip <= length(code) then
		    puts(1,"\n" & code[ip][1] & ":\n")
		    for i = 1 to length(code[ip][2]) do
			display_arg(code[ip][2][i])
		    end for
		end if
	    elsif equal(line[1],"regs") then
		if length(line) = 1 then
		    printf(1,"\neax %d\nebx %d\necx %d\nedx %d\nedi %d\nesi %d\n",registers)
		else
		    printf(1,"\n" & line[2] & " %d\n",GetValue({REGISTER,line[2]}))
		    output = GetValue({REGISTER,line[2]})
		end if
	    elsif equal(line[1],"exit") then
		exit
	    elsif equal(line[1],"peek") and length(line) = 2 then
		t = value(line[2])
		if t[1] = GET_SUCCESS then
		    if sequence(t[2]) then
			if t[2][1] > length(memory) or t[2][1] < 1 or t[2][1]+t[2][2]-1 > length(memory) or t[2][1]+t[2][2]-1 < 1 then
			    puts(1,"That memory doesn't exist.\n")
			else
			    ? memory[t[2][1]..t[2][1]+t[2][2]-1]
			    output = memory[t[2][1]..t[2][1]+t[2][2]-1]
			end if
		    else
			if t[2] > length(memory) or t[2] < 1 then
			    puts(1,"That memory doesn't exist.\n")
			else
			    ? memory[t[2]]
			    output = memory[t[2]]
			end if
		    end if
		end if
	    elsif equal(line[1],"poke") and length(line) = 3 then
		t = value(line[2])
		if t[1] = GET_SUCCESS then
		    t2 = value(line[3])
		    if sequence(t2[2]) then
			if t[2] > length(memory) or t[2] < 1 or t[2]+length(t2[2])-1 > length(memory) then
			    puts(1,"That memory doesn't exist.\n")
			else
			    for i = 1 to length(t2[2]) do
				memory[t[2]+i-1] = t2[2][i]
			    end for
			end if
		    else
			if t[2] > length(memory) or t[2] < 1 then
			    puts(1,"That memory doesn't exist.\n")
			else
			    memory[t[2]] = t2[2]
			end if
		    end if
		end if
	    elsif equal(line[1],"allocate") and length(line) = 2 then
		t = value(line[2])
		if t[1] = GET_SUCCESS then
		    ? length(memory)+1
		    output = length(memory)+1
		    memory &= repeat(0,t[2])
		end if
	    elsif equal(line[1],"label") and length(line) = 3 then
		t = 0
		for i = 1 to length(labels) do
		    if equal(line[2],labels[i][1]) then
			t = value(line[3])
			labels[i][2] = t[2]
			t = 1
			exit
		    end if
		end for
		if not t then
		    t = value(line[3])
		    labels = append(labels,{line[2],t[2]})
		end if
	    elsif equal(line[1],"setip") and length(line) = 2 then
		t = value(line[2])
		if t[1] = GET_SUCCESS then
		    if integer(t[2]) then
			if t[2] > 0 and t[2] <= length(code) then
			    ip = t[2]
			end if
		    end if
		end if
		printf(1,"ip=%d\n",ip)
	    elsif equal(line[1],"getip") then
		printf(1,"ip=%d\n",ip)
		output = ip
	    elsif equal(line[1],"runcmds") and length(line) = 2 then
		t = open(line[2],"r")
		if t = -1 then
		    puts(1,"can't open " & line[2] & "\n")
		else
		    debugger(t)
		    close(t)
		end if
	    elsif equal(line[1],"help") then
		puts(1,"load [file]     loads code from file or keyboard (blank line ends)\n")
		puts(1,"run             runs currently loaded code\n")
		puts(1,"step            runs currenc command\n")
		puts(1,"code            displays current command\n")
		puts(1,"regs [reg]      displays registers or label named reg\n")
		puts(1,"exit            exits the interpreter\n")
		puts(1,"peek arg        like peek(arg)\n")
		puts(1,"allocate n      allocates n bytes\n")
		puts(1,"label l v       sets label l to value v\n")
		puts(1,"setip ip        sets instruction pointer to ip\n")
		puts(1,"getip           displays instruction pointer to ip\n")
		puts(1,"runcmds file    runs commands from a file\n")
		puts(1,"poke mem data   like poke(mem,data)\n")
		puts(1,"help            displays help\n")
	    end if
	end if
	line = gets(f)
    end while
end procedure
ip = -1
code = {}
memory = {}
labels = {}
debugger(0)
